name: Tests

on:
  push:
    branches: [master]
  pull_request:
    branches: [master]

jobs:
  test:
    runs-on: ubuntu-latest
    strategy:
      fail-fast: true
      matrix:
        php: [7.4, 8.0, 8.1]
        laravel: [5.8.*, 6.4.*, 7.*, 8.*, 9.*]
        include:
          - laravel: 5.8.*
            testbench: ^3.4
            larastan: ^0.4
          - laravel: 6.4.*
            testbench: ^4.0
            larastan: ^1.0
          - laravel: 7.*
            testbench: ^5.0
            larastan: ^1.0
          - laravel: 8.*
            testbench: ^6.0
            larastan: ^1.0
          - laravel: 9.*
            testbench: ^7.0
            larastan: ^2.0
        exclude:
          - php: 7.4
            laravel: 9.*
          - php: 8.0
            laravel: 5.8.*
          - php: 8.0
            laravel: 6.4.*
          - php: 8.1
            laravel: 5.8.*
          - php: 8.1
            laravel: 6.4.*
          - php: 8.1
            laravel: 7.*

    name: P${{ matrix.php }} - L${{ matrix.laravel }}

    steps:
      - name: Checkout code
        uses: actions/checkout@v2

      - name: Setup PHP
        uses: shivammathur/setup-php@v2
        with:
          php-version: ${{ matrix.php }}
          extensions: dom, curl, libxml, mbstring, zip, pcntl, pdo, sqlite, pdo_sqlite, bcmath, soap, intl, gd, exif, iconv, imagick, fileinfo
          coverage: none

      - name: Install dependencies
        run: |
          composer require "laravel/framework:${{ matrix.laravel }}" "orchestra/testbench:${{ matrix.testbench }}" "nunomaduro/larastan:${{ matrix.larastan }}" --no-interaction --no-update
          composer update --prefer-dist --no-interaction

      - name: Execute tests
        run: vendor/bin/phpunit
